﻿using System;

namespace Magify
{
    internal sealed class Subscription : IDisposable
    {
        private Action _unsubscribeAction;
        
        public Subscription(Action unsubscribeAction)
        {
            _unsubscribeAction = unsubscribeAction;
        }
        
        public void Dispose()
        {
            _unsubscribeAction?.Invoke();
            _unsubscribeAction = default;
        }
    }
}